
set echo on
set serveroutput on

DECLARE

   TYPE varchar2_array IS TABLE OF VARCHAR2(30)
      INDEX BY BINARY_INTEGER;

   TYPE record_type IS RECORD
   (  inner_array varchar2_array );

   TYPE varchar2_multi IS TABLE OF record_type
      INDEX BY BINARY_INTEGER;

   outer_array varchar2_multi;

BEGIN

   /* Load a dense multilevel array... */
   FOR v_outer IN 1 .. 5 LOOP
      FOR v_inner IN 1 .. (v_outer*10) LOOP
         outer_array(v_outer).inner_array(v_inner) := 'A value';
      END LOOP;
   END LOOP;

   /* Loop through the outer array only... */
   FOR i IN outer_array.FIRST .. outer_array.LAST LOOP
      DBMS_OUTPUT.PUT_LINE(
         'Outer element ' || i || ' is an array with ' || 
          outer_array(i).inner_array.COUNT || ' elements.'
         );
   END LOOP;

END;
/

