
set echo on
set serveroutput on

DECLARE

   TYPE varchar2_array IS TABLE OF VARCHAR2(30)
      INDEX BY BINARY_INTEGER;

   TYPE record_type IS RECORD
   (  inner_array varchar2_array );

   TYPE varchar2_multi IS TABLE OF record_type
      INDEX BY BINARY_INTEGER;

   outer_array varchar2_multi;

   v_elements  PLS_INTEGER := 0;

BEGIN

   /* Load a dense multilevel array... */
   FOR v_outer IN 1 .. 5 LOOP
      FOR v_inner IN 1 .. (v_outer*10) LOOP
         outer_array(v_outer).inner_array(v_inner) := 'A value';
      END LOOP;
   END LOOP;

   /* Access all elements of all arrays... */
   FOR v_outer IN outer_array.FIRST .. outer_array.LAST LOOP
      FOR v_inner IN outer_array(v_outer).inner_array.FIRST .. 
                        outer_array(v_outer).inner_array.LAST
      LOOP
         v_elements := v_elements + 1;
      END LOOP;
   END LOOP;

   DBMS_OUTPUT.PUT_LINE(
      'Processed ' || v_elements || ' array elements.'
      );

END;
/

