
set echo on
set serveroutput on

DECLARE

   TYPE varchar2_array IS TABLE OF VARCHAR2(30)
      INDEX BY BINARY_INTEGER;

   TYPE record_type IS RECORD
   (  inner_array varchar2_array );

   TYPE varchar2_multi IS TABLE OF record_type
      INDEX BY BINARY_INTEGER;

   outer_array varchar2_multi;

   v_outer    PLS_INTEGER;
   v_inner    PLS_INTEGER;
   v_elements PLS_INTEGER := 0;

BEGIN

   /* Load a dense multilevel array... */
   FOR v_outer IN 1 .. 5 LOOP
      FOR v_inner IN 1 .. (v_outer*10) LOOP
         outer_array(v_outer).inner_array(v_inner) := 'A value';
      END LOOP;
   END LOOP;

   /* Loop as if they were sparse... */
   v_outer := outer_array.FIRST;
   WHILE v_outer IS NOT NULL LOOP

      v_inner := outer_array(v_outer).inner_array.FIRST;
      WHILE v_inner IS NOT NULL LOOP

         v_elements := v_elements + 1;
         v_inner := outer_array(v_outer).inner_array.NEXT(v_inner);

      END LOOP;

      v_outer := outer_array.NEXT(v_outer);

   END LOOP;
         
   DBMS_OUTPUT.PUT_LINE(
      'Processed ' || v_elements || ' array elements.'
      );

END;
/

